<?php

namespace Drupal\igbinary\Component\Serialization;

use Drupal\Component\Serialization\SerializationInterface;

/**
 * Igbinary serialization for serialized PHP.
 */
class IgbinarySerialize implements SerializationInterface {

  /**
   * {@inheritdoc}
   */
  public static function encode($data) {
    return igbinary_serialize($data);
  }

  /**
   * {@inheritdoc}
   */
  public static function decode($raw) {
    if (strpos($raw, "\x00") === 0) {
      return igbinary_unserialize($raw);
    }
    elseif (strpos($raw, ':') === 1) {
      // Fallback for existing values serialized with PHP.
      return unserialize($raw);
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getFileExtension() {
    return 'igbinary';
  }

}
